xref: /openbmc/linux/scripts/link-vmlinux.sh (revision 8851b9f1)
1#!/bin/sh
2#
3# link vmlinux
4#
5# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
6# $(KBUILD_VMLINUX_MAIN). Most are built-in.o files from top-level directories
7# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
8# Ordering when linking is important, and $(KBUILD_VMLINUX_INIT) must be first.
9#
10# vmlinux
11#   ^
12#   |
13#   +-< $(KBUILD_VMLINUX_INIT)
14#   |   +--< init/version.o + more
15#   |
16#   +--< $(KBUILD_VMLINUX_MAIN)
17#   |    +--< drivers/built-in.o mm/built-in.o + more
18#   |
19#   +-< ${kallsymso} (see description in KALLSYMS section)
20#
21# vmlinux version (uname -v) cannot be updated during normal
22# descending-into-subdirs phase since we do not yet know if we need to
23# update vmlinux.
24# Therefore this step is delayed until just before final link of vmlinux.
25#
26# System.map is generated to document addresses of all kernel symbols
27
28# Error out on error
29set -e
30
31# Nice output in kbuild format
32# Will be supressed by "make -s"
33info()
34{
35	if [ "${quiet}" != "silent_" ]; then
36		printf "  %-7s %s\n" ${1} ${2}
37	fi
38}
39
40# Link of vmlinux.o used for section mismatch analysis
41# ${1} output file
42modpost_link()
43{
44	${LD} ${LDFLAGS} -r -o ${1} ${KBUILD_VMLINUX_INIT}                   \
45		--start-group ${KBUILD_VMLINUX_MAIN} --end-group
46}
47
48# Link of vmlinux
49# ${1} - optional extra .o files
50# ${2} - output file
51vmlinux_link()
52{
53	local lds="${objtree}/${KBUILD_LDS}"
54
55	if [ "${SRCARCH}" != "um" ]; then
56		${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2}                  \
57			-T ${lds} ${KBUILD_VMLINUX_INIT}                     \
58			--start-group ${KBUILD_VMLINUX_MAIN} --end-group ${1}
59	else
60		${CC} ${CFLAGS_vmlinux} -o ${2}                              \
61			-Wl,-T,${lds} ${KBUILD_VMLINUX_INIT}                 \
62			-Wl,--start-group                                    \
63				 ${KBUILD_VMLINUX_MAIN}                      \
64			-Wl,--end-group                                      \
65			-lutil ${1}
66		rm -f linux
67	fi
68}
69
70
71# Create ${2} .o file with all symbols from the ${1} object file
72kallsyms()
73{
74	info KSYM ${2}
75	local kallsymopt;
76
77	if [ -n "${CONFIG_HAVE_UNDERSCORE_SYMBOL_PREFIX}" ]; then
78		kallsymopt="${kallsymopt} --symbol-prefix=_"
79	fi
80
81	if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
82		kallsymopt="${kallsymopt} --all-symbols"
83	fi
84
85	local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL}               \
86		      ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
87
88	${NM} -n ${1} | \
89		scripts/kallsyms ${kallsymopt} | \
90		${CC} ${aflags} -c -o ${2} -x assembler-with-cpp -
91}
92
93# Create map file with all symbols from ${1}
94# See mksymap for additional details
95mksysmap()
96{
97	${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
98}
99
100sortextable()
101{
102	${objtree}/scripts/sortextable ${1}
103}
104
105# Delete output files in case of error
106trap cleanup SIGHUP SIGINT SIGQUIT SIGTERM ERR
107cleanup()
108{
109	rm -f .old_version
110	rm -f .tmp_System.map
111	rm -f .tmp_kallsyms*
112	rm -f .tmp_version
113	rm -f .tmp_vmlinux*
114	rm -f System.map
115	rm -f vmlinux
116	rm -f vmlinux.o
117}
118
119#
120#
121# Use "make V=1" to debug this script
122case "${KBUILD_VERBOSE}" in
123*1*)
124	set -x
125	;;
126esac
127
128if [ "$1" = "clean" ]; then
129	cleanup
130	exit 0
131fi
132
133# We need access to CONFIG_ symbols
134case "${KCONFIG_CONFIG}" in
135*/*)
136	. "${KCONFIG_CONFIG}"
137	;;
138*)
139	# Force using a file from the current directory
140	. "./${KCONFIG_CONFIG}"
141esac
142
143#link vmlinux.o
144info LD vmlinux.o
145modpost_link vmlinux.o
146
147# modpost vmlinux.o to check for section mismatches
148${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
149
150# Update version
151info GEN .version
152if [ ! -r .version ]; then
153	rm -f .version;
154	echo 1 >.version;
155else
156	mv .version .old_version;
157	expr 0$(cat .old_version) + 1 >.version;
158fi;
159
160# final build of init/
161${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
162
163kallsymso=""
164kallsyms_vmlinux=""
165if [ -n "${CONFIG_KALLSYMS}" ]; then
166
167	# kallsyms support
168	# Generate section listing all symbols and add it into vmlinux
169	# It's a three step process:
170	# 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
171	#     but __kallsyms is empty.
172	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
173	#     the right size
174	# 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
175	#     the right size, but due to the added section, some
176	#     addresses have shifted.
177	#     From here, we generate a correct .tmp_kallsyms2.o
178	# 2a) We may use an extra pass as this has been necessary to
179	#     woraround some alignment related bugs.
180	#     KALLSYMS_EXTRA_PASS=1 is used to trigger this.
181	# 3)  The correct ${kallsymso} is linked into the final vmlinux.
182	#
183	# a)  Verify that the System.map from vmlinux matches the map from
184	#     ${kallsymso}.
185
186	kallsymso=.tmp_kallsyms2.o
187	kallsyms_vmlinux=.tmp_vmlinux2
188
189	# step 1
190	vmlinux_link "" .tmp_vmlinux1
191	kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
192
193	# step 2
194	vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
195	kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
196
197	# step 2a
198	if [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
199		kallsymso=.tmp_kallsyms3.o
200		kallsyms_vmlinux=.tmp_vmlinux3
201
202		vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
203
204		kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
205	fi
206fi
207
208info LD vmlinux
209vmlinux_link "${kallsymso}" vmlinux
210
211if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
212	info SORTEX vmlinux
213	sortextable vmlinux
214fi
215
216info SYSMAP System.map
217mksysmap vmlinux System.map
218
219# step a (see comment above)
220if [ -n "${CONFIG_KALLSYMS}" ]; then
221	mksysmap ${kallsyms_vmlinux} .tmp_System.map
222
223	if ! cmp -s System.map .tmp_System.map; then
224		echo >&2 Inconsistent kallsyms data
225		echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
226		cleanup
227		exit 1
228	fi
229fi
230
231# We made a new kernel - delete old version file
232rm -f .old_version
233